VERSION 5.00
Begin VB.UserControl ProgressBar 
   ClientHeight    =   465
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   PropertyPages   =   "ProgressBar.ctx":0000
   ScaleHeight     =   31
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   ToolboxBitmap   =   "ProgressBar.ctx":0038
End
Attribute VB_Name = "ProgressBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private MrkCount As Double
Private MrkSize As SIZEAPI

Private m_pDC As Long
Private m_pBitmap As Long

Private m_pTextDC As Long
Private m_pTextBitmap As Long

Private m_pTextBrush As Long

Private m_pBrush As Long
Private m_pFont As Long

Public Enum ProgressBarStyles
    psMagicSquares = 0&
    psFade = 1&
End Enum

Public Enum TextAlignConstants
    taLeft = 0&
    taRight = 1
    taCenter = 2
End Enum

Public Enum TextVAlignConstants
    taTop = 0&
    taBottom = 1&
End Enum

Public Enum OrientationConstants
    ocHorizontal = 1
    ocHorizontalRightToLeft = 3
    ocVertical = 4
    ocVerticalBottomToTop = 6
End Enum

Private Const ReverseMask = 2

Public Enum BorderStyleConstants
    bsNone = 0&
    bsSunken3D = 1
    bsRaised3D = 2
    bsSunkenBox = 3
    bsRaisedBox = 4
End Enum

Private m_DoEvents As Boolean

Private m_ClickableTiles As Boolean
Private m_TileDown As Long

Private m_MaxValue As Double
Private m_MinValue As Double
Private m_Value As Double

Private m_Style As ProgBarCtl.ProgressBarStyles

Private m_Orientation As ProgBarCtl.OrientationConstants
Private m_BorderStyle As ProgBarCtl.BorderStyleConstants

Private m_TextBorderStyle As ProgBarCtl.BorderStyleConstants

Private m_BackColor As OLE_COLOR
Private m_ForeColor As OLE_COLOR

Private m_TextColor As OLE_COLOR
Private m_TextBkColor As OLE_COLOR

Private WithEvents m_Font As StdFont
Attribute m_Font.VB_VarHelpID = -1

Private m_Text As String
Private m_TextAreaHeight As Long

Private m_TextAlign As ProgBarCtl.TextAlignConstants
Private m_TextVAlign As ProgBarCtl.TextVAlignConstants

Private m_TextArea As RECT

Private m_ValFmt As String
Private m_PercFmt As String

Public Event TileClick(ByVal TileNumber As Long, ByVal TileCount As Long, ByVal Button As Integer)

Public Property Get TextAreaHeight() As Long
    TextAreaHeight = m_TextAreaHeight
End Property

Public Property Let TextAreaHeight(ByVal varNew As Long)
    If (m_TextAreaHeight <> varNew) Then
    
        m_TextAreaHeight = varNew
        PropertyChanged "TextAreaHeight"
        
        UserControl_Paint
    End If
End Property

Public Property Get ClickableTiles() As Boolean
    ClickableTiles = m_ClickableTiles
End Property

Public Property Let ClickableTiles(ByVal varNew As Boolean)
    If (m_ClickableTiles <> varNew) Then
        
        m_ClickableTiles = varNew
        PropertyChanged "ClickableTiles"
        UserControl_Paint
    End If
    
End Property

Public Property Get TextAlign() As ProgBarCtl.TextAlignConstants
    TextAlign = m_TextAlign
End Property

Public Property Get TextVAlign() As ProgBarCtl.TextVAlignConstants
    TextVAlign = m_TextVAlign
End Property

Public Property Get Text() As String
Attribute Text.VB_Description = "Returns/sets the text format string that will be displayed in the control.\r\n\r\nEscape codes are: \\p - percentage, \\v - Value, \\m - MaxValue, \\z - MinValue"
Attribute Text.VB_ProcData.VB_Invoke_Property = ";Text"
Attribute Text.VB_UserMemId = -517
    Text = m_Text
End Property

Public Property Get PercentFormat() As String
Attribute PercentFormat.VB_Description = "Returns/sets the format string for percentage values inserted into the control text with the '\\p' escape code."
Attribute PercentFormat.VB_ProcData.VB_Invoke_Property = ";Appearance"
    PercentFormat = m_PercFmt
End Property

Public Property Get ValueFormat() As String
Attribute ValueFormat.VB_Description = "Returns/sets the format string for values inserted into the control text with the '\\v','\\m' & '\\z'   escape codes."
Attribute ValueFormat.VB_ProcData.VB_Invoke_Property = ";Appearance"
    ValueFormat = m_ValFmt
End Property

Public Property Get DoAppEvents() As Boolean
Attribute DoAppEvents.VB_Description = "Returns/sets a value indicating whether the control will process application events after completing a paint procedure."
Attribute DoAppEvents.VB_ProcData.VB_Invoke_Property = ";Behavior"
    DoAppEvents = m_DoEvents
End Property

Public Property Get Font() As StdFont
Attribute Font.VB_Description = "Click the ellipses to open the font properties dialog."
Attribute Font.VB_ProcData.VB_Invoke_Property = "StandardFont;Font"
Attribute Font.VB_UserMemId = -512
    Set Font = m_Font
End Property

Public Property Get MaxValue() As Double
Attribute MaxValue.VB_Description = "Returns/sets the maximum allowable value of the 'Value' property."
Attribute MaxValue.VB_ProcData.VB_Invoke_Property = ";Behavior"
    MaxValue = m_MaxValue
End Property

Public Property Get MinValue() As Double
Attribute MinValue.VB_Description = "Returns/sets the minimum allowable value of the 'Value' property."
Attribute MinValue.VB_ProcData.VB_Invoke_Property = ";Behavior"
    MinValue = m_MinValue
End Property

Public Property Get Value() As Double
Attribute Value.VB_Description = "Returns/sets the value of the internal counter of the control.  The allowable values range is defined by the MinValue and MaxValue properties."
Attribute Value.VB_ProcData.VB_Invoke_Property = ";Data"
Attribute Value.VB_UserMemId = 0
Attribute Value.VB_MemberFlags = "200"
    Value = m_Value
End Property

Public Property Get Style() As ProgBarCtl.ProgressBarStyles
    Style = m_Style
End Property

Public Property Get BorderStyle() As ProgBarCtl.BorderStyleConstants
Attribute BorderStyle.VB_Description = "Returns/sets the border style of the control.\r\nbsRaised - Draws the control similar to a button.\r\nbsSunken - draws the control similar to a window.\r\nbsNone - Draws no border around the control."
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BorderStyle.VB_UserMemId = -504
    BorderStyle = m_BorderStyle
End Property

Public Property Get TextBorderStyle() As ProgBarCtl.BorderStyleConstants
    TextBorderStyle = m_TextBorderStyle
End Property

Public Property Get Orientation() As ProgBarCtl.OrientationConstants
Attribute Orientation.VB_Description = "Returns/sets the orientation of the control."
Attribute Orientation.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Orientation = m_Orientation
End Property

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background fill color of the control."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackColor.VB_UserMemId = -501
    BackColor = m_BackColor
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground fill color of the control."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute ForeColor.VB_UserMemId = -513
    ForeColor = m_ForeColor
End Property

Public Property Get TextColor() As OLE_COLOR
Attribute TextColor.VB_Description = "Returns/sets the text color of the control."
Attribute TextColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    TextColor = m_TextColor
End Property

Public Property Get TextBkColor() As OLE_COLOR
    TextBkColor = m_TextBkColor
End Property

Public Property Let TextAlign(ByVal varNew As ProgBarCtl.TextAlignConstants)
Attribute TextAlign.VB_Description = "Returns/sets the text alignment of the control."
Attribute TextAlign.VB_ProcData.VB_Invoke_PropertyPut = ";Appearance"
    If m_TextAlign <> varNew Then
        m_TextAlign = varNew
        PropertyChanged "TextAlign"
        
        UpdateText
    End If
    
End Property

Public Property Let TextVAlign(ByVal varNew As ProgBarCtl.TextVAlignConstants)
    If m_TextVAlign <> varNew Then
        
        m_TextVAlign = varNew
        PropertyChanged "TextVAlign"
        
        MeasureTextArea
        UserControl_Paint
    End If
    
End Property

Public Property Let Text(ByVal varNew As String)
    
    If varNew <> m_Text Then
        m_Text = varNew
        PropertyChanged "Text"
        
        UpdateText
    End If

End Property

Public Property Let PercentFormat(ByVal varNew As String)
    
    If varNew <> m_PercFmt Then
        m_PercFmt = varNew
        PropertyChanged "PercentFormat"
        
        UpdateText
    End If

End Property

Public Property Let ValueFormat(ByVal varNew As String)
    
    If varNew <> m_ValFmt Then
        m_ValFmt = varNew
        PropertyChanged "ValueFormat"
        
        UpdateText
    End If

End Property

Public Property Let DoAppEvents(ByVal varNew As Boolean)
    
    If m_DoEvents <> varNew Then
        m_DoEvents = varNew
        PropertyChanged "DoAppEvents"
    End If
    
End Property

Private Sub m_Font_FontChanged(ByVal PropertyName As String)
    Dim lpFont As LOGFONT
    
    PropertyChanged "Font"
    
    If m_pFont <> 0& Then
        DeleteObject m_pFont
    End If
    
    GetLogFont m_Font, lpFont, hdc
    m_pFont = CreateFontIndirect(lpFont)
    
    If m_pTextDC <> 0& Then
        SelectObject m_pTextDC, m_pFont
        UpdateText
    End If
    
End Sub

Public Property Set Font(ByVal sFont As StdFont)
    Dim lpFont As LOGFONT
        
    If Not (m_Font Is sFont) Then
        Set m_Font = sFont
        
        If m_pFont <> 0& Then
            DeleteObject m_pFont
        End If
        
        MeasureTextArea
        UserControl_Paint
            
    End If
    
End Property

Public Property Let BorderStyle(ByVal varNew As ProgBarCtl.BorderStyleConstants)
    
    If Ambient.UserMode = False Then
        If m_BorderStyle <> varNew Then
            m_BorderStyle = varNew
            PropertyChanged "BorderStyle"
            UserControl_Paint
        End If
    Else
        Err.Raise 382
    End If

End Property

Public Property Let TextBorderStyle(ByVal varNew As ProgBarCtl.BorderStyleConstants)
    
    If Ambient.UserMode = False Then
        If m_TextBorderStyle <> varNew Then
            m_TextBorderStyle = varNew
            PropertyChanged "TextBorderStyle"
            UserControl_Paint
        End If
    Else
        Err.Raise 382
    End If

End Property

Public Property Let Style(ByVal varNew As ProgBarCtl.ProgressBarStyles)
    
    If Ambient.UserMode = False Then
        If m_Style <> varNew Then
            m_Style = varNew
            PropertyChanged "Style"
            UserControl_Paint
        End If
    Else
        Err.Raise 382
    End If

End Property

Public Property Let Orientation(ByVal varNew As ProgBarCtl.OrientationConstants)
    
    If Ambient.UserMode = False Then
        
        If m_Orientation <> varNew Then
            m_Orientation = varNew
            PropertyChanged "Orientation"
            
            Dim x As Long, _
                y As Long, _
                n As Long
                
            x = Width
            y = Height
            
            If ((x < y) And (varNew And ocHorizontal)) _
                Or ((y < x) And (varNew And ocVertical)) Then
                
                n = x
                x = y
                y = n
                
                Extender.Move Extender.Left, Extender.Top, x, y
                
            End If

            UpdateText
        
            UserControl_Resize
        End If
        
    Else
        Err.Raise 382
    End If

End Property

Public Property Let BackColor(ByVal varNew As OLE_COLOR)
    Dim lpBrush As LOGBRUSH
    
    If varNew <> m_BackColor Then
        m_BackColor = varNew
        
        DeleteObject m_pBrush
        
        lpBrush.lbColor = OleToColor(m_BackColor)
        lpBrush.lbStyle = BS_SOLID
        
        m_pBrush = CreateBrushIndirect(lpBrush)
        
        PropertyChanged "BackColor"
        
        UserControl_Paint
    End If
End Property

Public Property Let ForeColor(ByVal varNew As OLE_COLOR)
    If varNew <> m_ForeColor Then
        m_ForeColor = varNew
        PropertyChanged "ForeColor"
        
        UserControl_Paint
    End If
End Property

Public Property Let TextColor(ByVal varNew As OLE_COLOR)
    
    If varNew <> m_TextColor Then
        m_TextColor = varNew
        PropertyChanged "TextColor"
        
        If m_pTextDC <> 0& Then
            SetTextColor m_pTextDC, OleToColor(m_TextColor)
        End If
        
        UserControl_Paint
    End If
    
End Property

Public Property Let TextBkColor(ByVal varNew As OLE_COLOR)
        
    Dim lpBrush As LOGBRUSH
    
    If varNew <> m_TextBkColor Then
        m_TextBkColor = varNew
        PropertyChanged "TextBkColor"
        
        If m_pTextDC <> 0& Then
            SetBkColor m_pTextDC, OleToColor(m_TextBkColor)
        End If
        
        If (m_pTextBrush <> 0&) Then
            DeleteObject m_pTextBrush
        End If
        
        With lpBrush
            .lbColor = OleToColor(m_TextBkColor)
            .lbStyle = BS_SOLID
        End With
        
        m_pTextBrush = CreateBrushIndirect(lpBrush)
        
        UserControl_Paint
    End If
    
End Property

Public Property Let MaxValue(ByVal varNew As Double)
    If varNew <> m_MaxValue Then
        If varNew <= m_MinValue Then Exit Property
        
        m_MaxValue = varNew
        PropertyChanged "MaxValue"
                
        If (m_Value > m_MaxValue) Then
            m_Value = m_MaxValue
        End If
        
        DrawMagicSquares
    End If
End Property

Public Property Let MinValue(ByVal varNew As Double)
    If varNew <> m_MinValue Then
        If varNew >= m_MaxValue Then Exit Property
        
        m_MinValue = varNew
        PropertyChanged "MinValue"
                
        If (m_Value < m_MinValue) Then
            m_Value = m_MinValue
        End If
        
        DrawMagicSquares
    End If
End Property

Public Property Let Value(ByVal varNew As Double)
    
    Dim b As Boolean
    
    If (m_Value = varNew) Then
        UserControl_Paint
        Exit Property
    End If
    
    b = (m_Value > varNew)
    m_Value = varNew
    
    If (m_Value > m_MaxValue) Then
        m_Value = m_MaxValue
    ElseIf (m_Value < m_MinValue) Then
        m_Value = m_MinValue
    End If
    
    If (b = True) Then
        UserControl_Paint
    Else
        
        Select Case m_Style
            Case psMagicSquares:
                DrawMagicSquares
                
            Case psFade:
                DrawMagicSquares , True
                
        End Select
    
    End If
    
    PropertyChanged "Value"

End Property

Public Sub Reset()
Attribute Reset.VB_Description = "Reset the value to the minimum value."
    
    m_Value = m_MinValue
    PropertyChanged "Value"
    
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

    If (m_TileDown = -1&) And (m_ClickableTiles) Then
        Dim lpPoint As POINTAPI
        
        With lpPoint
            .x = x
            .y = y
        End With
        
        ClickTile lpPoint, False, (m_Style = psFade)
        RaiseEvent TileClick(m_TileDown, MrkCount, Button)
        
    End If

End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)

    If (m_TileDown <> -1&) And (m_ClickableTiles) Then
        Dim lpPoint As POINTAPI
        
        With lpPoint
            .x = x
            .y = y
        End With
        
        ClickTile lpPoint, True, (m_Style = psFade)
    End If
    
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Dim lpBrush As LOGBRUSH, _
        lpFont As LOGFONT
    
    m_Style = PropBag.ReadProperty("Style", m_Style)
    
    m_Orientation = PropBag.ReadProperty("Orientation", m_Orientation)
    m_BorderStyle = PropBag.ReadProperty("BorderStyle", m_BorderStyle)
    m_TextBorderStyle = PropBag.ReadProperty("TextBorderStyle", m_TextBorderStyle)
    m_BackColor = PropBag.ReadProperty("BackColor", m_BackColor)
    m_ForeColor = PropBag.ReadProperty("ForeColor", m_ForeColor)
    m_TextColor = PropBag.ReadProperty("TextColor", m_TextColor)
    m_TextBkColor = PropBag.ReadProperty("TextBkColor", m_TextBkColor)
    
    m_TextAreaHeight = PropBag.ReadProperty("TextAreaHeight", m_TextAreaHeight)
    
    m_MaxValue = PropBag.ReadProperty("MaxValue", m_MaxValue)
    m_MinValue = PropBag.ReadProperty("MinValue", m_MinValue)
    m_Value = PropBag.ReadProperty("Value", m_Value)
    
    m_Text = PropBag.ReadProperty("Text", m_Text)
    m_TextAlign = PropBag.ReadProperty("TextAlign", m_TextAlign)
    m_TextVAlign = PropBag.ReadProperty("TextVAlign", m_TextVAlign)
    
    m_DoEvents = PropBag.ReadProperty("DoAppEvents", m_DoEvents)
    m_ClickableTiles = PropBag.ReadProperty("ClickableTiles", m_ClickableTiles)
    
    If m_pBrush <> 0& Then
        DeleteObject m_pBrush
    End If
    
    lpBrush.lbColor = OleToColor(m_BackColor)
    lpBrush.lbHatch = BS_SOLID
    
    m_pBrush = CreateBrushIndirect(lpBrush)
    
    lpBrush.lbColor = OleToColor(m_TextBkColor)
    m_pTextBrush = CreateBrushIndirect(lpBrush)
    
    Set m_Font = PropBag.ReadProperty("Font", m_Font)
    
    GetLogFont m_Font, lpFont, hdc
    
    If m_pFont <> 0& Then
        DeleteObject m_pFont
    End If
        
    MeasureTextArea
    
    m_ValFmt = PropBag.ReadProperty("ValueFormat", m_ValFmt)
    m_PercFmt = PropBag.ReadProperty("PercentFormat", m_PercFmt)
    
    UserControl.Refresh
    
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    
    PropBag.WriteProperty "Style", m_Style
    
    PropBag.WriteProperty "BorderStyle", m_BorderStyle
    PropBag.WriteProperty "TextBorderStyle", m_TextBorderStyle
    
    PropBag.WriteProperty "Orientation", m_Orientation
    PropBag.WriteProperty "BackColor", m_BackColor
    PropBag.WriteProperty "ForeColor", m_ForeColor
    PropBag.WriteProperty "TextColor", m_TextColor
    PropBag.WriteProperty "TextBkColor", m_TextBkColor
    
    PropBag.WriteProperty "TextAreaHeight", m_TextAreaHeight
    
    PropBag.WriteProperty "MaxValue", m_MaxValue
    PropBag.WriteProperty "MinValue", m_MinValue
    PropBag.WriteProperty "Value", m_Value
    
    PropBag.WriteProperty "DoAppEvents", m_DoEvents
    
    PropBag.WriteProperty "Font", m_Font
    
    PropBag.WriteProperty "ClickableTiles", m_ClickableTiles
    
    PropBag.WriteProperty "Text", m_Text
    PropBag.WriteProperty "TextAlign", m_TextAlign
    PropBag.WriteProperty "TextVAlign", m_TextVAlign
    
    PropBag.WriteProperty "ValueFormat", m_ValFmt
    PropBag.WriteProperty "PercentFormat", m_PercFmt
    
End Sub

Private Sub UserControl_Resize()
    
    If m_pDC <> 0& Then
        DeleteObject m_pBitmap
        
        m_pBitmap = 0&
    End If
    
    If m_pTextDC <> 0& Then
        DeleteObject m_pTextBitmap
        
        m_pTextBitmap = 0&
    End If
    
    MeasureTextArea

End Sub

Private Property Get PixelWidth() As Double
    PixelWidth = Width / 15
End Property

Private Property Get PixelHeight() As Double
    PixelHeight = Height / 15
End Property

Private Sub BltToScreen()
    
    BitBlt hdc, 0&, 0&, PixelWidth, PixelHeight, m_pDC, 0&, 0&, SRCCOPY

End Sub

Private Sub UserControl_Paint()
        
    Dim lpRect As RECT, _
        lpFont As LOGFONT
    
    Dim v As Long
    
    If m_pDC = 0& Then
        m_pDC = CreateCompatibleDC(hdc)
        MeasureTextArea
    End If
    
    If m_pBitmap = 0& Then
        m_pBitmap = CreateCompatibleBitmap(hdc, PixelWidth, PixelHeight)
        SelectObject m_pDC, m_pBitmap
    End If
        
    lpRect.Right = PixelWidth
    lpRect.Bottom = PixelHeight
    
    FillRect m_pDC, lpRect, m_pBrush
        
    lpRect.Bottom = lpRect.Bottom - 1
    lpRect.Right = lpRect.Right - 1
    
    If (m_Orientation And ocHorizontal) Then
        If (m_TextVAlign = taBottom) Then
            lpRect.Bottom = m_TextArea.Top - 1
        Else
            lpRect.Top = m_TextArea.Bottom + 1
        End If
    End If
    
    If (m_BorderStyle <> bsNone) Then
        
        Select Case m_BorderStyle
        
            Case bsSunken3D:
                Draw3DFrame_Sunken m_pDC, lpRect
                
            Case bsRaised3D:
                Draw3DFrame_Raised m_pDC, lpRect
            
            Case bsSunkenBox:
                Draw3DBox_Sunken m_pDC, lpRect
            
            Case bsRaisedBox:
                Draw3DBox_Raised m_pDC, lpRect
        
        End Select
        
    End If
    
    Select Case m_Style
    
        Case psMagicSquares
            DrawMagicSquares True
        
        Case psFade
            DrawMagicSquares True, True
        
    End Select
    
End Sub

Private Sub MeasureTextArea()

    Dim lpSize As SIZEAPI, _
        lpFont As LOGFONT

    If (m_pDC = 0&) Then Exit Sub
    
    If (m_pTextDC <> 0&) Then
        DeleteObject m_pTextBitmap
    End If
    
    If m_pFont = 0& Then
        GetLogFont m_Font, lpFont, m_pDC
        m_pFont = CreateFontIndirect(lpFont)
        
        SelectObject m_pDC, m_pFont
        If (m_pTextDC <> 0&) Then SelectObject m_pTextDC, m_pFont
    End If
        
    MeasureText_API m_pDC, c_AlphaStr, lpSize
    
    If (m_TextAreaHeight > 0&) Then
        lpSize.cy = m_TextAreaHeight
    ElseIf (m_TextAreaHeight <= -1&) Then
        lpSize.cy = 0&
        MrkCount = Markers(MrkSize)
    
        Exit Sub
    End If
    
    With m_TextArea
        
        Select Case m_Orientation
        
            Case ocHorizontal, ocHorizontalRightToLeft
            
                .Left = 0&
                .Right = PixelWidth
                
                Select Case m_TextVAlign
                
                    Case taTop
                        .Top = 0&
                        .Bottom = lpSize.cy + 4
                        
                    Case taBottom
                        .Bottom = PixelHeight
                        .Top = .Bottom - (lpSize.cy + 4)
                                            
                End Select
    
                If (m_pTextDC <> 0&) Then
                    m_pTextBitmap = CreateCompatibleBitmap(hdc, (.Right - .Left) + 1, (.Bottom - .Top) + 1)
                
                    SelectObject m_pTextDC, m_pTextBitmap
                    SelectObject m_pTextDC, m_pFont
            
                    SetTextColor m_pTextDC, OleToColor(m_TextColor)
                    SetBkMode m_pTextDC, TRANSPARENT
                End If
                        
            Case Else
            
                '' text is no longer available in the vertical orientation
                '' as of Version 2.0.
            
                .Top = 0&
                .Bottom = 0&
                .Right = 0&
                .Left = 0&
                    
        End Select
    
    End With
    
    MrkCount = Markers(MrkSize)
    
End Sub

Private Sub UpdateText()
    Dim lpFont As LOGFONT
        
    Dim lpBrush As LOGBRUSH
    
    Dim vText As String, _
        sPVal As Double
        
    Dim lpSize As SIZEAPI, _
        x As Long, _
        y As Long, _
        l As Long
    
    Dim lpRect As RECT
    
    If (m_TextAreaHeight <= -1&) Or (m_pFont = 0&) Or (m_Orientation And ocVertical) Then Exit Sub
    
    If (m_pTextDC = 0&) Then
        m_pTextDC = CreateCompatibleDC(hdc)
        SetBkMode m_pTextDC, TRANSPARENT
        SetBkColor m_pTextDC, OleToColor(m_TextBkColor)
        SetTextColor m_pTextDC, OleToColor(m_TextColor)
        
        SelectObject m_pTextDC, m_pFont
        MeasureTextArea
    End If
    
    If (m_pTextBrush = 0&) Then
        With lpBrush
            .lbColor = OleToColor(m_TextBkColor)
            .lbStyle = BS_SOLID
        End With
        
        m_pTextBrush = CreateBrushIndirect(lpBrush)
    End If
    
    With m_TextArea
        lpRect.Left = 0
        lpRect.Top = 0
        lpRect.Right = (.Right - .Left) + 1
        lpRect.Bottom = (.Bottom - .Top) + 1
    End With
    
    FillRect m_pTextDC, lpRect, m_pTextBrush
        
    With lpRect
        .Right = .Right - 2
        .Bottom = .Bottom - 2
    End With
    
    Select Case m_TextBorderStyle
    
        Case bsSunken3D:
            Draw3DFrame_Sunken m_pTextDC, lpRect
            
        Case bsRaised3D:
            Draw3DFrame_Raised m_pTextDC, lpRect
        
        Case bsSunkenBox:
            Draw3DBox_Sunken m_pTextDC, lpRect
        
        Case bsRaisedBox:
            Draw3DBox_Raised m_pTextDC, lpRect
    
    End Select
    
    
    sPVal = (m_Value / (m_MaxValue - m_MinValue)) * 100
    
    vText = InsertStr(m_Text, "\p", sPVal, m_PercFmt)
    vText = InsertStr(vText, "\v", m_Value, m_ValFmt)
    vText = InsertStr(vText, "\m", m_MaxValue, m_ValFmt)
    vText = InsertStr(vText, "\z", m_MinValue, m_ValFmt)
    
    If m_Text <> "" Then
        
        MeasureText_API m_pTextDC, vText, lpSize
    
        Select Case m_TextAlign
        
            Case taRight:
        
                x = lpRect.Right - (lpSize.cx + 6)
                
            Case taLeft:
            
                x = 4&
            
            Case taCenter:
            
                x = (lpRect.Right / 2) - (lpSize.cx / 2)
            
        End Select
        
        y = (lpRect.Bottom / 2) - (lpSize.cy / 2)
                                                
        TextOut_API m_pTextDC, vText, x, y
        
    End If

    With m_TextArea
        BitBlt m_pDC, .Left, .Top, lpRect.Right + 1, lpRect.Bottom + 1, m_pTextDC, 0&, 0&, SRCCOPY
    End With
    
End Sub

Private Sub DrawMagicSquares(Optional ByVal RepaintAll As Boolean, Optional ByVal Fade As Boolean)

    Dim lpGradient As GRADIENTSTRUCT, _
        lpRect As RECT, _
        lpSize As SIZEAPI, _
        lpPoint As POINTAPI
        
    Dim lpBrush As LOGBRUSH, _
        hBrush As Long
        
    Dim x As Double, _
        y As Long, _
        n As Long
        
    Dim s As Double, _
        t As Double, _
        u As Double
            
    Dim sStart As Double
    
    Static rcPos As Long
        
    If MrkCount = 0& Then Exit Sub
    
    With lpGradient
        
        .BaseColor = OleToColor(m_BackColor)
        .FinalColor = OleToColor(m_ForeColor)
    
    End With
    
    If (Fade) Then x = 1 Else _
        x = MrkCount
        
    If (Fade) Then
        If (m_Orientation And ocHorizontal) Then
            lpSize.cx = PixelWidth - 4
            lpSize.cy = MrkSize.cy
        Else
            lpSize.cx = MrkSize.cx
            lpSize.cy = PixelHeight - 4
        End If
    Else
        lpSize.cx = MrkSize.cx
        lpSize.cy = MrkSize.cy
    End If
               
    s = (m_MaxValue - m_MinValue) / x
        
    If Not RepaintAll = True Then
        t = (m_Value - m_MinValue) / x
    
        If Round(t) < t Then
            t = Round(t) + 1
        Else
            t = Round(t)
        End If
        
        If rcPos <> t Then
        
            rcPos = t
            sStart = m_MinValue
        
        Else
        
            For u = m_MinValue To m_Value Step s
            
                If (u + s) > m_Value Then
                    sStart = u
                    Exit For
                End If
                
                y = y + 1
            
            Next u
        
        End If
        
    Else
        
        sStart = m_MinValue
    
    End If
    
    hBrush = 0&
    For u = sStart To m_Value Step s
        
        If ((u + s) > m_Value) Then
            
            If CSng(m_MaxValue - m_Value) < Abs(s) Then
                t = 1# - (CSng(m_MaxValue - m_Value) / Abs(s))
            Else
                t = (m_Value - u) / Abs(s)
            End If
            
            lpGradient.Percentage = t
            
            If hBrush <> 0& Then
                DeleteObject hBrush
            End If
            
            lpBrush.lbColor = GetGradColor(lpGradient)
            hBrush = CreateBrushIndirect(lpBrush)
            
        Else
            If hBrush = 0& Then
                lpBrush.lbColor = lpGradient.FinalColor
                lpBrush.lbStyle = BS_SOLID
                
                hBrush = CreateBrushIndirect(lpBrush)
            End If
        End If
        
        Select Case m_Orientation
            
            Case ocHorizontal:
                
                lpRect.Top = 2
                lpRect.Left = (y * (lpSize.cx + 1)) + 2
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                
                If lpRect.Right < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Left < 2 Then
                    lpRect.Left = 2
                End If
                
                If lpRect.Left > (PixelWidth - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Right > (PixelWidth - 2) Then
                    lpRect.Right = PixelWidth - 2
                End If
                
                If (m_TextVAlign = taTop) Then
                    ShiftRect lpRect, 0, m_TextArea.Bottom
                End If
                
            Case ocHorizontalRightToLeft:
                                
                lpRect.Top = 2
                lpRect.Left = PixelWidth - (((y + 1) * (lpSize.cx + 1)) + 2)
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                
                If lpRect.Right < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Left < 2 Then
                    lpRect.Left = 2
                End If
                
                If lpRect.Left > (PixelWidth - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Right > (PixelWidth - 2) Then
                    lpRect.Right = PixelWidth - 2
                End If
                
                If (m_TextVAlign = taTop) Then
                    ShiftRect lpRect, 0, m_TextArea.Bottom
                End If
            
            Case ocVertical:
            
                lpRect.Top = (y * (lpSize.cy + 1)) + 2
                lpRect.Left = 2
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                
                If lpRect.Bottom < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Top < 2 Then
                    lpRect.Top = 2
                End If
                
                If lpRect.Top > (PixelHeight - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Bottom > (PixelHeight - 2) Then
                    lpRect.Bottom = PixelHeight - 2
                End If
                
            Case ocVerticalBottomToTop:
        
                lpRect.Top = PixelHeight - (((y + 1) * (lpSize.cy + 1)) + 2)
                lpRect.Left = 2
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                                                       
                If lpRect.Bottom < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Top < 2 Then
                    lpRect.Top = 2
                End If
                
                If lpRect.Top > (PixelHeight - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Bottom > (PixelHeight - 2) Then
                    lpRect.Bottom = PixelHeight - 2
                End If
                
        End Select
        
        If lpRect.Left <> -1& Then
            FillRect m_pDC, lpRect, hBrush
            
            With lpRect
                .Right = .Right - 1
                .Bottom = .Bottom - 1
            End With
            
            If (m_ClickableTiles = True) And (m_Value <> 0&) Then
                
                If (m_TileDown = y) Then
                    Draw3DBox_Sunken m_pDC, lpRect
                Else
                    Draw3DBox_Raised m_pDC, lpRect
                End If
            
            End If
        End If
        
        y = y + 1
        
    Next u
    
    DeleteObject hBrush
    UpdateText
    BltToScreen
    
    If m_DoEvents Then
        DoEvents
    End If
        
End Sub

Private Sub ClickTile(Mouse As POINTAPI, Optional ByVal Unclick As Boolean, Optional ByVal Fade As Boolean)

    Dim lpRect As RECT, _
        lpSize As SIZEAPI, _
        lpPoint As POINTAPI
        
    Dim x As Double, _
        y As Long, _
        n As Long
        
    Dim s As Double, _
        t As Double, _
        u As Double
            
    Dim sStart As Double
    
    If (MrkCount = 0&) Or (m_Value = 0&) Then Exit Sub
    
    If (Fade) Then x = 1 Else _
        x = MrkCount
        
    If (Fade) Then
        If (m_Orientation And ocHorizontal) Then
            lpSize.cx = PixelWidth - 4
            lpSize.cy = MrkSize.cy
        Else
            lpSize.cx = MrkSize.cx
            lpSize.cy = PixelHeight - 4
        End If
    Else
        lpSize.cx = MrkSize.cx
        lpSize.cy = MrkSize.cy
    End If
               
    s = (m_MaxValue - m_MinValue) / x
            
    sStart = m_MinValue
    
    For u = sStart To m_Value Step s
        
        Select Case m_Orientation
            
            Case ocHorizontal:
                
                lpRect.Top = 2
                lpRect.Left = (y * (lpSize.cx + 1)) + 2
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                
                If lpRect.Right < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Left < 2 Then
                    lpRect.Left = 2
                End If
                
                If lpRect.Left > (PixelWidth - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Right > (PixelWidth - 2) Then
                    lpRect.Right = PixelWidth - 2
                End If
                
                If (m_TextVAlign = taTop) Then
                    ShiftRect lpRect, 0, m_TextArea.Bottom
                End If
                
            Case ocHorizontalRightToLeft:
                                                                
                lpRect.Top = 2
                lpRect.Left = PixelWidth - (((y + 1) * (lpSize.cx + 1)) + 2)
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                
                If lpRect.Right < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Left < 2 Then
                    lpRect.Left = 2
                End If
                
                If lpRect.Left > (PixelWidth - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Right > (PixelWidth - 2) Then
                    lpRect.Right = PixelWidth - 2
                End If
                
                If (m_TextVAlign = taTop) Then
                    ShiftRect lpRect, 0, m_TextArea.Bottom
                End If
            
            Case ocVertical:
            
                lpRect.Top = (y * (lpSize.cy + 1)) + 2
                lpRect.Left = 2
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                
                If lpRect.Bottom < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Top < 2 Then
                    lpRect.Top = 2
                End If
                
                If lpRect.Top > (PixelHeight - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Bottom > (PixelHeight - 2) Then
                    lpRect.Bottom = PixelHeight - 2
                End If
                
            Case ocVerticalBottomToTop:
        
                lpRect.Top = PixelHeight - (((y + 1) * (lpSize.cy + 1)) + 2)
                lpRect.Left = 2
                lpRect.Bottom = lpRect.Top + lpSize.cy
                lpRect.Right = lpRect.Left + lpSize.cx
                                                       
                If lpRect.Bottom < 2 Then
                    lpRect.Left = -1&
                ElseIf lpRect.Top < 2 Then
                    lpRect.Top = 2
                End If
                
                If lpRect.Top > (PixelHeight - 2) Then
                    lpRect.Left = -1&
                ElseIf lpRect.Bottom > (PixelHeight - 2) Then
                    lpRect.Bottom = PixelHeight - 2
                End If
                
        End Select
        
        If lpRect.Left <> -1& Then
            If (WithinRect(lpRect, Mouse.x, Mouse.y) = True) Or (m_TileDown = y) Then
            
                With lpRect
                    .Right = .Right - 1
                    .Bottom = .Bottom - 1
                End With
                
                If (Unclick = True) Then
                    Draw3DBox_Raised m_pDC, lpRect
                    m_TileDown = -1&
                Else
                    m_TileDown = y
                    Draw3DBox_Sunken m_pDC, lpRect
                End If
            End If
        End If
        
        y = y + 1
        
    Next u
    
    BltToScreen
    
End Sub

Private Function Markers(lpSize As SIZEAPI) As Double
    Dim mH As Long, _
        mW As Long
    
    If (m_Orientation And ocVertical) Then
        
        mW = PixelWidth - 4
        mH = mW
    
        Markers = ((PixelHeight - 3) / (mH + 1))
        
    ElseIf (m_Orientation And ocHorizontal) Then
    
        mH = PixelHeight - 4
        
        mH = mH - ((m_TextArea.Bottom - m_TextArea.Top) + 1)
        mW = mH
        
        Markers = ((PixelWidth - 3) / (mW + 1))
            
    End If
    
    If Round(Markers) < Markers Then
        If (Markers - Round(Markers)) >= 0.2 Then
            Markers = Round(Markers) + 1
        Else
            Markers = Round(Markers)
        End If
    Else
        Markers = Round(Markers)
    End If
        
    lpSize.cx = mW
    lpSize.cy = mH
        
End Function

Private Sub UserControl_Initialize()
    
    Dim lpBrush As LOGBRUSH

    m_BorderStyle = bsSunken3D
    m_TextBorderStyle = bsRaised3D
    
    m_Orientation = ocHorizontal
    
    m_BackColor = &H80000000 + COLOR_BTNFACE
    m_ForeColor = &H80000000 + COLOR_HIGHLIGHT
    
    m_TextColor = &H80000000 + COLOR_BTNTEXT
    m_TextBkColor = &H80000000 + COLOR_BTNFACE
    
    m_Style = psMagicSquares
    
    m_Value = 0#
    m_MaxValue = 100#
    m_MinValue = 0#
        
    Set m_Font = New StdFont
    
    lpBrush.lbColor = OleToColor(m_BackColor)
    lpBrush.lbHatch = BS_SOLID
    
    m_pBrush = CreateBrushIndirect(lpBrush)

    m_Text = "\p%"
    
    m_TextAlign = taCenter
    m_TextVAlign = taBottom
    
    m_ValFmt = "#####0.00"
    m_PercFmt = "##0&"

    m_TileDown = -1&
    
End Sub

Private Sub UserControl_Terminate()
    
    If m_pDC <> 0& Then
        DeleteDC m_pDC
        DeleteObject m_pBitmap
    End If
    
    If m_pTextDC <> 0& Then
        DeleteObject m_pTextDC
        DeleteObject m_pTextBitmap
    End If
    
    DeleteObject m_pBrush
    DeleteObject m_pFont
    
    DeleteObject m_pTextBrush
    
End Sub
