Attribute VB_Name = "modDraw_Base"
Option Explicit
Option Base 0

'' Global Variables for Unicode (Used By the Text Functions)

Global Unicode_Checked As Boolean
Global Using_Unicode As Boolean

Public Const c_AlphaStr As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789!@#$%^&*()_-+=~`[]{}\|;:'<>,./?"

Public Sub CheckUnicode()
    Dim lpOS As OSVERSIONINFO
    
    lpOS.OSVersionInfoSize = Len(lpOS)
    GetVersion lpOS
    
    If (lpOS.PlatformId = VER_PLATFORM_WIN32_NT) Then
        Using_Unicode = True
        
    Else
        Using_Unicode = False
    End If
    
    Unicode_Checked = True
    
End Sub


''' Draw 3D Borders

'' Heavy Raised (3D Buttons, Forms or Menus)

Public Function Draw3DFrame_Raised(ByVal hdc As Long, lpRect As RECT, Optional ByVal dwPenStyle As Long = PS_SOLID)
    Dim hPen As Long, _
        x As Long, _
        y As Long, _
        lpPoint As POINTAPI
    
    Dim hOldPen As Long, _
        crColor As Long
        
    With lpRect
        crColor = GetSysColor(COLOR_3DLIGHT)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        hOldPen = SelectObject(hdc, hPen)
    
        x = .Left
        y = .Bottom
        
        MoveToEx hdc, x, y, lpPoint
        y = .Top
        
        LineTo hdc, x, y
        x = .Right
        LineTo hdc, x, y
        
        SelectObject hdc, hOldPen
        DeleteObject hPen
        
        crColor = GetSysColor(COLOR_BTNHIGHLIGHT)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        SelectObject hdc, hPen
        
        x = .Left + 1&
        y = .Bottom - 1&
        
        MoveToEx hdc, x, y, lpPoint
        y = .Top + 1&
        
        LineTo hdc, x, y
        x = .Right - 1&
        LineTo hdc, x, y
        
        SelectObject hdc, hOldPen
        DeleteObject hPen
        
        crColor = GetSysColor(COLOR_3DDKSHADOW)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        SelectObject hdc, hPen
        
        x = .Right
        y = .Top
        
        MoveToEx hdc, x, y, lpPoint
        y = .Bottom
        LineTo hdc, x, y
        
        x = .Left
        LineTo hdc, x, y
        
        SelectObject hdc, hOldPen
        DeleteObject hPen
        
        crColor = GetSysColor(COLOR_BTNSHADOW)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        SelectObject hdc, hPen
        
        x = .Right - 1&
        y = .Top + 1&
        
        MoveToEx hdc, x, y, lpPoint
        y = .Bottom - 1&
        LineTo hdc, x, y
        
        x = .Left + 1&
        LineTo hdc, x, y
    
    End With
            
    SelectObject hdc, hOldPen
    DeleteObject hPen
    
End Function


'' Heavy Sunken (3D Controls)

Public Function Draw3DFrame_Sunken(ByVal hdc As Long, lpRect As RECT, Optional ByVal dwPenStyle As Long = PS_SOLID)
    Dim hPen As Long, _
        x As Long, _
        y As Long, _
        lpPoint As POINTAPI
    
    Dim hOldPen As Long, _
        crColor As Long
        
    With lpRect
        crColor = GetSysColor(COLOR_3DDKSHADOW)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        hOldPen = SelectObject(hdc, hPen)
    
        x = .Left
        y = .Bottom
        
        MoveToEx hdc, x, y, lpPoint
        y = .Top
        
        LineTo hdc, x, y
        x = .Right
        LineTo hdc, x, y
        
        SelectObject hdc, hOldPen
        DeleteObject hPen
        
        crColor = GetSysColor(COLOR_BTNSHADOW)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        SelectObject hdc, hPen
        
        x = .Left + 1&
        y = .Bottom - 1&
        
        MoveToEx hdc, x, y, lpPoint
        y = .Top + 1&
        
        LineTo hdc, x, y
        x = .Right - 1&
        LineTo hdc, x, y
        
        SelectObject hdc, hOldPen
        DeleteObject hPen
        
        crColor = GetSysColor(COLOR_BTNHIGHLIGHT)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        SelectObject hdc, hPen
        
        x = .Right
        y = .Top
        
        MoveToEx hdc, x, y, lpPoint
        y = .Bottom
        LineTo hdc, x, y
        
        x = .Left
        LineTo hdc, x, y
        
            
        SelectObject hdc, hOldPen
        DeleteObject hPen
        
        crColor = GetSysColor(COLOR_3DLIGHT)
        hPen = CreatePen(PS_SOLID, 1&, crColor)
        
        SelectObject hdc, hPen
        
        x = .Right - 1&
        y = .Top + 1&
        
        MoveToEx hdc, x, y, lpPoint
        y = .Bottom - 1&
        LineTo hdc, x, y
        
        x = .Left + 1&
        LineTo hdc, x, y
    
    End With
            
    SelectObject hdc, hOldPen
    DeleteObject hPen
    
End Function

'' Light Raised (Highlighted/Bordered)

Public Function Draw3DBox_Raised(ByVal hdc As Long, lpRect As RECT)

    Dim hPen As Long, _
        hOldPen As Long
    
    Dim lpPoint As POINTAPI
        
    hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT))
    
    hOldPen = SelectObject(hdc, hPen)
    
    MoveToEx hdc, lpRect.Right, lpRect.Top, lpPoint
    LineTo hdc, lpRect.Left, lpRect.Top
    LineTo hdc, lpRect.Left, lpRect.Bottom
    
    SelectObject hdc, hOldPen
    DeleteObject hPen
    
    hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW))
    
    SelectObject hdc, hPen
    
    MoveToEx hdc, lpRect.Right, lpRect.Top, lpPoint
    LineTo hdc, lpRect.Right, lpRect.Bottom
    LineTo hdc, lpRect.Left, lpRect.Bottom
    
    SelectObject hdc, hOldPen
    DeleteObject hPen

End Function

'' Light Sunken (Selected/Bordered)

Public Function Draw3DBox_Sunken(ByVal hdc As Long, lpRect As RECT)

    Dim hPen As Long, _
        hOldPen As Long
    
    Dim lpPoint As POINTAPI
        
    hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW))
    
    hOldPen = SelectObject(hdc, hPen)
    
    MoveToEx hdc, lpRect.Right, lpRect.Top, lpPoint
    LineTo hdc, lpRect.Left, lpRect.Top
    LineTo hdc, lpRect.Left, lpRect.Bottom
    
    SelectObject hdc, hOldPen
    DeleteObject hPen
    
    hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT))
    
    SelectObject hdc, hPen
    
    MoveToEx hdc, lpRect.Right, lpRect.Top, lpPoint
    LineTo hdc, lpRect.Right, lpRect.Bottom
    LineTo hdc, lpRect.Left, lpRect.Bottom
    
    SelectObject hdc, hOldPen
    DeleteObject hPen

End Function

'' Dotted Work Frame

Public Function DrawWorkFrame(ByVal hdc As Long, lpRect As RECT)
    Dim hPen As Long, _
        hOldPen As Long
        
    Dim lpPoint As POINTAPI
        
    hPen = CreatePen(PS_DOT, 1&, GetSysColor(COLOR_HIGHLIGHT))
    hOldPen = SelectObject(hdc, hPen)
    
    With lpRect
        MoveToEx hdc, .Left, .Top, lpPoint

        LineTo hdc, .Right, .Top
        LineTo hdc, .Right, .Bottom
        LineTo hdc, .Left, .Bottom
        LineTo hdc, .Left, .Top
    
        MoveToEx hdc, .Left + 1, .Top + 1, lpPoint

        LineTo hdc, .Right - 1, .Top + 1
        LineTo hdc, .Right - 1, .Bottom - 1
        LineTo hdc, .Left + 1, .Bottom - 1
        LineTo hdc, .Left + 1, .Top + 1
    
    End With
    
    SelectObject hdc, hOldPen
    DeleteObject hPen
    
End Function

Public Function BevelBox(ByVal hdc As Long, lpRect As RECT, Optional ByVal Reversed As Boolean)
        
    Dim rcFill As RECT, _
        lpBrush As LOGBRUSH, _
        hBrush As Long
                
    Dim hPen As Long, _
        hOldPen As Long
                
    Dim lpPoint As POINTAPI
    
    If (Reversed = True) Then
        hPen = CreatePen(PS_SOLID, 2&, GetSysColor(COLOR_BTNHIGHLIGHT))
        lpBrush.lbColor = GetSysColor(COLOR_BTNSHADOW)
    Else
        hPen = CreatePen(PS_SOLID, 2&, GetSysColor(COLOR_BTNSHADOW))
        lpBrush.lbColor = GetSysColor(COLOR_BTNHIGHLIGHT)
    End If
    
    lpBrush.lbStyle = BS_SOLID
    
    hOldPen = SelectObject(hdc, hPen)
    hBrush = CreateBrushIndirect(lpBrush)
                
    With rcFill
        .Left = lpRect.Right - 1&
        .Top = lpRect.Top
        .Right = lpRect.Right
        .Bottom = lpRect.Bottom
    End With
    
    FillRect hdc, rcFill, hBrush
    
    With rcFill
        MoveToEx hdc, .Left, .Top + 1&, lpPoint
        LineTo hdc, .Left, .Bottom - 1&
    End With

    With rcFill
        .Left = lpRect.Left
        .Top = lpRect.Bottom - 1&
        .Right = lpRect.Right
        .Bottom = lpRect.Bottom
    End With
    
    FillRect hdc, rcFill, hBrush
    
    With rcFill
        MoveToEx hdc, .Left + 1&, .Top, lpPoint
        LineTo hdc, .Right - 1&, .Top
    End With

    DeleteObject hBrush
    
    SelectObject hdc, hOldPen
    DeleteObject hPen
    
    If (Reversed = True) Then
        hPen = CreatePen(PS_SOLID, 2&, GetSysColor(COLOR_BTNSHADOW))
        lpBrush.lbColor = GetSysColor(COLOR_BTNHIGHLIGHT)
    Else
        hPen = CreatePen(PS_SOLID, 2&, GetSysColor(COLOR_BTNHIGHLIGHT))
        lpBrush.lbColor = GetSysColor(COLOR_BTNSHADOW)
    End If
    
    lpBrush.lbStyle = BS_SOLID
    
    SelectObject hdc, hPen
    hBrush = CreateBrushIndirect(lpBrush)
    
    With rcFill
        .Left = lpRect.Left
        .Top = lpRect.Top + 1&
        .Right = lpRect.Left + 1&
        .Bottom = lpRect.Bottom - 1&
    End With
    
    FillRect hdc, rcFill, hBrush
    
    With rcFill
        MoveToEx hdc, .Right, .Top, lpPoint
        LineTo hdc, .Right, .Bottom
    End With
                
    With rcFill
        .Left = lpRect.Left + 1&
        .Top = lpRect.Top
        .Right = lpRect.Right - 1&
        .Bottom = lpRect.Top + 1&
    End With
    
    FillRect hdc, rcFill, hBrush
    
    With rcFill
        MoveToEx hdc, .Left, .Bottom, lpPoint
        LineTo hdc, .Right, .Bottom
    End With
    
    DeleteObject hBrush
    
    SelectObject hdc, hOldPen
    DeleteObject hPen

End Function


Public Function FlatBox(ByVal hdc As Long, lpRect As RECT, ByVal crColor As Long, Optional ByVal crBackColor As Long = -1&)
        
    Dim hPen As Long, _
        hOldPen As Long
        
    Dim lpPoint As POINTAPI, _
        lpBrush As LOGBRUSH, _
        hBrush As Long
        
    If (crBackColor <> -1&) Then
        lpBrush.lbColor = GetActualColor(crBackColor)
        lpBrush.lbStyle = BS_SOLID
        
        hBrush = CreateBrushIndirect(lpBrush)
        FillRect hdc, lpRect, hBrush
        
        DeleteObject hBrush
    End If
    
    hPen = CreatePen(PS_SOLID, 1&, crColor)
    hOldPen = SelectObject(hdc, hPen)
    
    With lpRect
        MoveToEx hdc, .Left, .Top, lpPoint
        
        LineTo hdc, .Left, .Bottom
        LineTo hdc, .Right, .Bottom
        LineTo hdc, .Right, .Top
        LineTo hdc, .Left, .Top
    End With
    
    SelectObject hdc, hOldPen
    DeleteObject hPen
        
End Function


'' Bevel Line

Public Function BevelLine(ByVal hdc As Long, PointA As POINTAPI, PointB As POINTAPI, Optional ByVal Vertical As Boolean, Optional ByVal Inverse As Boolean)

    Dim hPen As Long, _
        lpPoint As POINTAPI, _
        hOldPen As Long
        
    hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT))
    hOldPen = SelectObject(hdc, hPen)
    
    MoveToEx hdc, PointA.x, PointA.y, lpPoint
    LineTo hdc, PointB.x, PointB.y
    
    SelectObject hdc, hOldPen
    DeleteObject hPen
    
    hPen = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW))
    SelectObject hdc, hPen
        
    If (Vertical = True) Then
        
        If Inverse = True Then
            MoveToEx hdc, PointA.x - 1, PointA.y, lpPoint
            LineTo hdc, PointB.x - 1, PointB.y
        Else
            MoveToEx hdc, PointA.x + 1, PointA.y, lpPoint
            LineTo hdc, PointB.x + 1, PointB.y
        End If
    Else
        If Inverse = True Then
            MoveToEx hdc, PointA.x, PointA.y + 1, lpPoint
            LineTo hdc, PointB.x, PointB.y + 1
        Else
            MoveToEx hdc, PointA.x, PointA.y - 1, lpPoint
            LineTo hdc, PointB.x, PointB.y - 1
        End If
    End If
    
    SelectObject hdc, hOldPen
    DeleteObject hPen

    MoveToEx hdc, lpPoint.x, lpPoint.y, lpPoint
    
End Function


'''' Text Rendering / Measuring Functions


'' Unicode Text Measure

Public Function MeasureText_API(ByVal hdc As Long, ByVal lpszText As String, _
                                lpSize As SIZEAPI, _
                                Optional ByVal fHasAccel As Boolean) As Long
                                 
    Dim cx As Long, _
        cy As Long
        
    Dim i As Long, _
        j As Long
        
    Dim cMeasure As SIZEAPI
        
    Dim bLine() As Byte, _
        lSize As Long, _
        lpPtr As Long, _
        x As Long
                
    Dim sStr As String
                
    If (Unicode_Checked = False) Then CheckUnicode
        
        On Error Resume Next
                        
        sStr = lpszText
                
        lSize = Len(sStr)
        
        If (Using_Unicode = True) Then
            x = (lSize * 2&)
            ReDim bLine(0& To (x + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(sStr), x
            lpPtr = VarPtr(bLine(0&))
            
            GetTextExtentPoint32W hdc, lpPtr, lSize, cMeasure
            Erase bLine
        Else
            sStr = StrConv(sStr, vbFromUnicode)
            x = LenB(sStr)
            ReDim bLine(0& To (x + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(sStr), x
            lpPtr = VarPtr(bLine(0&))
            
            GetTextExtentPoint32 hdc, lpPtr, x, cMeasure
            Erase bLine
        End If
    
        If (cx < cMeasure.cx) Then cx = cMeasure.cx
        cy = cy + cMeasure.cy
        
    lpSize.cx = cx
    lpSize.cy = cy
        
    If (lSize <> 0&) Then
        MeasureText_API = True
    End If
    
End Function



Public Function MeasureLines_API(ByVal hdc As Long, lpLines() As String, _
                                lpSize As SIZEAPI, _
                                Optional ByVal fHasAccel As Boolean) As Long
                                 
    Dim cx As Long, _
        cy As Long
        
    Dim i As Long, _
        j As Long
        
    Dim cMeasure As SIZEAPI
        
    Dim bLine() As Byte, _
        lSize As Long, _
        lpPtr As Long, _
        x As Long
                            
                
    Dim sStr As String
                
    If (Unicode_Checked = False) Then CheckUnicode
        
    On Error Resume Next
                    
    i = -1&
    i = UBound(lpLines)
    
    For j = 0 To i
        
        sStr = lpLines(j)
        lSize = Len(sStr)
        
        If (Using_Unicode = True) Then
            x = (lSize * 2&)
            ReDim bLine(0& To (x + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(sStr), x
            lpPtr = VarPtr(bLine(0&))
            
            GetTextExtentPoint32W hdc, lpPtr, lSize, cMeasure
            Erase bLine
        Else
            sStr = StrConv(sStr, vbFromUnicode)
            x = LenB(sStr)
            ReDim bLine(0& To (x + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(sStr), x
            lpPtr = VarPtr(bLine(0&))
            
            GetTextExtentPoint32 hdc, lpPtr, x, cMeasure
            Erase bLine
        End If
    
        If (cx < cMeasure.cx) Then cx = cMeasure.cx
        cy = cy + cMeasure.cy
        
    Next j
            
    lpSize.cx = cx
    lpSize.cy = cy
        
    If (lSize <> 0&) Then
        MeasureLines_API = True
    End If
    
End Function



'' Unicode Text Write Functions

'' TextOut
Public Function TextOut_API(ByVal hdc As Long, ByVal lpszText As String, _
                            ByVal x As Long, ByVal y As Long) As Long


    Dim i As Long, _
        j As Long
        
    Dim bLine() As Byte, _
        lSize As Long, _
        lpPtr As Long, _
        n As Long
               
    Dim szText As String
                
    If (Unicode_Checked = False) Then CheckUnicode
        
        On Error Resume Next
                
        lSize = Len(lpszText)
        
        If (Using_Unicode = True) Then
            n = (lSize * 2&)
            ReDim bLine(0& To (n + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(lpszText), n
            lpPtr = VarPtr(bLine(0&))
            
            TextOutW hdc, x, y, lpPtr, lSize
            Erase bLine
        Else
            szText = StrConv(lpszText, vbFromUnicode)
            n = LenB(szText)
            ReDim bLine(0& To n)
            
            CopyMemory bLine(0&), ByVal StrPtr(szText), n
            lpPtr = VarPtr(bLine(0&))
            
            TextOut hdc, x, y, lpPtr, n
            Erase bLine
        End If
    
End Function

'' Draw-Disabled
Public Function DrawDisabled_API(ByVal hdc As Long, ByVal lpszText As String, _
                                 ByVal x As Long, ByVal y As Long) As Long


    Dim i As Long, _
        j As Long
        
    Dim bLine() As Byte, _
        lSize As Long, _
        lpPtr As Long, _
        n As Long
    
    Dim szText As String
    
    n = 0&
    lpPtr = 0&
    
    If (Unicode_Checked = False) Then CheckUnicode
        
        On Error Resume Next
                
        lSize = Len(lpszText)
        
        If (lSize = 0&) Then
            Exit Function
        End If
        
        If (Using_Unicode = True) Then
            n = (lSize * 2&)
            ReDim bLine(0& To (n + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(lpszText), n
            lpPtr = VarPtr(bLine(0&))
        
            DrawStateW hdc, 0&, 0&, lpPtr, lSize, x, y, 0&, 0&, (DST_TEXT Or DSS_DISABLED)
        Else
            szText = StrConv(lpszText, vbFromUnicode)
            
            n = LenB(szText)
            ReDim bLine(0& To n)
            
            CopyMemory bLine(0&), ByVal StrPtr(szText), n
            lpPtr = VarPtr(bLine(0&))
            
            DrawState hdc, 0&, 0&, lpPtr, n, x, y, 0&, 0&, (DST_TEXT Or DSS_DISABLED)
        End If
        
        Erase bLine
        
End Function
                            

'' Draw-State
Public Function DrawStateText_API(ByVal hdc As Long, ByVal lpszText As String, _
                                  ByVal x As Long, ByVal y As Long, ByVal uFlags As Long, Optional ByVal hBrush As Long) As Long


    Dim i As Long, _
        j As Long
        
    Dim bLine() As Byte, _
        lSize As Long, _
        lpPtr As Long, _
        n As Long
    
    Dim szText As String
    
    n = 0&
    lpPtr = 0&
    
    If (Unicode_Checked = False) Then CheckUnicode
        
        On Error Resume Next
                
        lSize = Len(lpszText)
        
        If (lSize = 0&) Then
            Exit Function
        End If
        
        If (Using_Unicode = True) Then
            n = (lSize * 2&)
            ReDim bLine(0& To (n + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(lpszText), n
            lpPtr = VarPtr(bLine(0&))
        
            DrawStateW hdc, hBrush, 0&, lpPtr, lSize, x, y, 0&, 0&, (DST_TEXT Or uFlags)
        Else
            szText = StrConv(lpszText, vbFromUnicode)
            
            n = LenB(szText)
            ReDim bLine(0& To n)
            
            CopyMemory bLine(0&), ByVal StrPtr(szText), n
            lpPtr = VarPtr(bLine(0&))
            
            DrawState hdc, hBrush, 0&, lpPtr, n, x, y, 0&, 0&, (DST_TEXT Or uFlags)
        End If
        
        Erase bLine
        
End Function
                            
'' DrawText
Public Function DrawText_API(ByVal hdc As Long, ByVal lpszText As String, _
                             lpRect As RECT) As Long


    Dim i As Long, _
        j As Long
        
    Dim bLine() As Byte, _
        lSize As Long, _
        lpPtr As Long, _
        n As Long
                
    Dim szText As String
                
    If (Unicode_Checked = False) Then CheckUnicode
        
        On Error Resume Next
                
        lSize = Len(lpszText)
        
        If (Using_Unicode = True) Then
            n = (lSize * 2&)
            ReDim bLine(0& To (n + 1))
            
            CopyMemory bLine(0&), ByVal StrPtr(lpszText), n
            lpPtr = VarPtr(bLine(0&))
            
            DrawTextW hdc, lpPtr, lSize, lpRect, 0&
            Erase bLine
        Else
            szText = StrConv(lpszText, vbFromUnicode)
            n = LenB(szText)
            ReDim bLine(0 To n)
            
            CopyMemory bLine(0&), ByVal StrPtr(szText), n
            lpPtr = VarPtr(bLine(0&))
            
            DrawText hdc, lpPtr, n, lpRect, 0&
            Erase bLine
        End If
    
End Function

''' Copyright (C) 2001 Nathan Moschkin

''' ****************** NOT FOR COMMERCIAL USE *****************
''' Inquire if you would like to use this code commercially.
''' Unauthorized recompilation and/or re-release for commercial
''' use is strictly prohibited.
'''
''' please send changes made to code to me at the address, below,
''' if you plan on making those changes publicly available.

''' e-mail questions or comments to logeist@tampabay.rr.com



