Attribute VB_Name = "modGraphics"
Option Explicit

Public Type RGB
    Red As Byte
    Green As Byte
    Blue As Byte
End Type

Public Type GRADIENTSTRUCT
    BaseColor As Long
    FinalColor As Long
    Percentage As Single
End Type

Public Function Draw3DSquare(ByVal hdc As Long, rcBounds As RECT, Optional ByVal Etch As Boolean, Optional ByVal Raised As Boolean)

    Dim hPen1 As Long, _
        hPen2 As Long, _
        hOldPen As Long, _
        lpPoint As POINTAPI
    
    Dim x As Long, _
        y As Long, _
        X2 As Long, _
        Y2 As Long
        
    If Etch Then
        hPen1 = CreatePen(PS_SOLID, 1&, GetSysColor(COLOR_BTNSHADOW))
    Else
        hPen1 = CreatePen(PS_SOLID, 1&, GetSysColor(COLOR_WINDOWFRAME))
    End If
    
    hPen2 = CreatePen(PS_SOLID, 1&, GetSysColor(COLOR_BTNHIGHLIGHT))
    
    x = rcBounds.Left
    y = rcBounds.Top
    
    X2 = rcBounds.Right
    Y2 = rcBounds.Bottom
    
    If (Raised And True) Then
        hOldPen = SelectObject(hdc, hPen2)
    
        '' Draw bottom and right corners first
        
        MoveToEx hdc, x, Y2, lpPoint
        
        LineTo hdc, x, y
        LineTo hdc, X2, y
        
        SelectObject hdc, hPen1
                
        LineTo hdc, X2, Y2
        LineTo hdc, x, Y2
        
    Else
        hOldPen = SelectObject(hdc, hPen1)
    
        '' Draw left and top corners first
        
        MoveToEx hdc, x, Y2, lpPoint
        
        LineTo hdc, x, y
        LineTo hdc, X2, y
        
        SelectObject hdc, hPen2
                
        LineTo hdc, X2, Y2
        LineTo hdc, x, Y2
        
    End If
        
    SelectObject hdc, hOldPen
    DeleteObject hPen1
    DeleteObject hPen2
    
End Function

Public Function OleToColor(ByVal OleColor As OLE_COLOR) As Long

    If (OleColor And &H80000000) Then
        OleToColor = GetSysColor(OleColor And &HFF&)
    Else
        OleToColor = OleColor
    End If
End Function

Public Sub ColorToRGB(ByVal ColorRef As Long, Red As Byte, Green As Byte, Blue As Byte)

    Red = (ColorRef And &HFF&)
    Green = (ColorRef And &HFF00&) / &H100&
    Blue = (ColorRef And &HFF0000) / &H10000

End Sub

Public Function GetGradColor(lpGradient As GRADIENTSTRUCT) As Long

    Dim lpRgb As RGB, _
        lpFinalRgb As RGB
                    
    Dim c As Single
                
    Dim d As Integer, _
        e As Integer, _
        f As Integer
                                
    Dim x As Integer, _
        y As Integer, _
        z As Integer
        
    With lpGradient
        ColorToRGB .BaseColor, lpRgb.Red, lpRgb.Green, lpRgb.Blue
        ColorToRGB .FinalColor, lpFinalRgb.Red, lpFinalRgb.Green, lpFinalRgb.Blue
    
        c = .Percentage
    
    End With
    
    d = (CInt(lpFinalRgb.Red) - CInt(lpRgb.Red)) * c
    e = (CInt(lpFinalRgb.Green) - CInt(lpRgb.Green)) * c
    f = (CInt(lpFinalRgb.Blue) - CInt(lpRgb.Blue)) * c
    
    d = CInt(lpRgb.Red) + d
    e = CInt(lpRgb.Green) + e
    f = CInt(lpRgb.Blue) + f
        
    
    GetGradColor = RGB(d, e, f)

End Function

Public Function InsertStr(ByVal StrIn As String, ByVal StrEscape As String, Value, Optional FmtStr As String) As String

    Dim i As Long, _
        s1 As String, _
        s2 As String
        
    i = InStr(1, StrIn, StrEscape)
    If i = 0 Then
        InsertStr = StrIn
        Exit Function
    End If
    
    s1 = Mid(StrIn, 1, i - 1)
    s2 = Mid(StrIn, i + Len(StrEscape))
    
    s1 = s1 & Value & s2
    
    InsertStr = s1
    
End Function

Public Sub StringToCStr(ByVal vData As String, vCStr() As Byte, Optional ByVal FixedLen As Boolean)
    Dim i As Long, _
        s As String
    
    i = Len(vData)
    
    If (FixedLen = False) Then
        ReDim vCStr(0 To i)
    End If
    s = StrConv(vData, vbFromUnicode)
    CopyMemory vCStr(LBound(vCStr)), ByVal StrPtr(s), i
    
End Sub

Public Sub GetLogFont(OleFont As StdFont, lfData As LOGFONT, hdc As Long)

    With lfData
        .lfCharSet = OleFont.Charset
        .lfItalic = OleFont.Italic
        .lfWeight = OleFont.Weight
        
        If OleFont.Bold Then
            .lfWeight = 700
        End If
        
        .lfUnderline = OleFont.Underline
        StringToCStr OleFont.Name, .lfFaceName, True
        .lfStrikeOut = OleFont.Strikethrough
        .lfHeight = -(MulDiv(OleFont.Size, GetDeviceCaps(hdc, LOGPIXELSY), 72))
        .lfQuality = 2
        
    End With

End Sub


